var duree=0;
var chauffe=0;
var iTemps=0;
var playing=false;
var deltaT=20;
var minDeltaT=20;
var milli=0;
var lastMilli=0;

function changeVitesseAnim(v) {
	v=v*v;
	deltaT=1000/v;
}

function updateZoom () {
	byId("div_conteneur_modele").style.fontSize=Math.round(mainZoom*10)/1000+"em";
}

function nextTurn () {
	if (duree>0) {
		if (iTemps>=duree) {pause();return false}
	}
	milli= new Date().getTime();
	addDataToGraph();
	if ((milli-lastMilli)>minDeltaT) {
		traceGraph ();
	}
	iTemps++;
	vieillitEntites();
	checkDemiVie ();
	bougeEntites();
	testGenSpont();
	testReactions();
	doReactions ();
	compteCasesVides ();
	if ((milli-lastMilli)>minDeltaT) {
		traceEntites();
		updateTours();
		selectAgent(selectedAgent);
		lastMilli=milli;
	}		
}

function animate () {
	milli= new Date().getTime();
	if ((swal.isVisible()===false)&&(playing)&&(byId("masqueModal").style.display!="block")&&(byId("divDroiteDefaut").style.display=="block")) {
		nextTurn();
	}
	if (iTemps<0) {
		setTimeout (animate,1);
	} else {
		setTimeout (animate,deltaT);
	}
}

function updateTours() {
	byId("labelNTour").innerHTML=iTemps;
}

function play() {
	if (iTemps==0) {
		iTemps=-chauffe;
	}
	traceEntites();
	traceGraph(true);
	traceZones();
	updateTours();
	playing=true;
}


function pause() {
	traceEntites();
	traceGraph(true);
	traceZones();
	updateTours();
	playing=false;
}

function resetAnim() {

	swal({
		  title: 'Réinitialiser le modèle',
		  text: "Cette opération restaurera le modèle à son état initial. Etes vous sûr de vouloir réinitialiser (redémarrer) ce modèle ?",
		  type: 'warning',
		  showCancelButton: true,
		  confirmButtonColor: '#3085d6',
		  cancelButtonColor: '#d33',
		  confirmButtonText: 'Oui',
		  cancelButtonText: 'Non',
		  confirmButtonClass: 'btn btn-success',
		  cancelButtonClass: 'btn btn-danger',
		  buttonsStyling: true,
		  reverseButtons: false
		}).then((result) => {
		  if (result) {
			doResetAnim();
		  } else {
			return false;
		  }
		})

}

function doResetAnim() {
	playing=false;
	tan.pente="";
	clearTangente();
	damierZ=JSON.parse(JSON.stringify(damierZ0));
	iTemps=-chauffe;
	repeupleTout();
	traceEntites();
	traceGraph(true);
	traceZones();
	updateTours();
	selectAgent(selectedAgent);
}

function changeChauffe() {
	chauffe=byId("inputToursDeChauffe").value*1;	
	if (chauffe>999) {chauffe=999;}
	if (chauffe<0) {chauffe=0;}
	byId("inputToursDeChauffe").value=chauffe;
}

function changeDuree() {
	duree=byId("inputDuree").value*1;	
	if (duree>9999) {duree=9999;}
	if (duree<0) {duree=0;}
	byId("inputDuree").value=duree;
}