var modePlaceEntites=false;
var idEntPlace=-1;
var damierClic=false;
var modeOutilPlace="place";
var xSurvolDamier=-1;
var ySurvolDamier=-1;

function clickButBrosseEntite() {
	swal({
		  title: 'Suppression de tous les agents de type \"'+entById(idEntPlace).nom+'\"',
		  text: "Etes vous sûr de vouloir supprimer tous les agents de type \""+entById(idEntPlace).nom+"\" ?",
		  type: 'warning',
		  showCancelButton: true,
		  confirmButtonColor: '#3085d6',
		  cancelButtonColor: '#d33',
		  confirmButtonText: 'Oui',
		  cancelButtonText: 'Non',
		  confirmButtonClass: 'btn btn-success',
		  cancelButtonClass: 'btn btn-danger',
		  buttonsStyling: true,
		  reverseButtons: false
		}).then((result) => {
		  if (result.value) {
			tEnt[nEntById(idEntPlace)].tInd=[];
			traceEntites();
			updateNbInd();
		  } else {
			return false;
		  }
	})
}

function clickButFinPlacement() {
	updateEffectifLegende();
	modePlaceEntites=false;
	byId("canvEnv").style.cursor="default";
	hideId ("divDroitePositionne");
	showId ("divDroiteDefaut");
	showId ("divGaucheDefaut");
	// sauvegarde dans tPla
	var tPla=[];
	var tInd=tEnt[nEntById(idEntPlace)].tInd;
	for (let ind of tInd) {
		tPla.push(ind.x);
		tPla.push(ind.y);
	}
	tEnt[nEntById(idEntPlace)].tPla=tPla.slice();
	tEnt[nEntById(idEntPlace)].tInd=[];
	tEnt[nEntById(idEntPlace)].nbInd=-1;
	repeupleTout();
	traceEntites();
}


function clickButPlaceEntite() {
	modePlaceEntites=true;
	modeCrayonPlace();
	repeupleTout();
		
	idEntPlace=selectedAgent;
	
	byId("canvEnv").style.cursor="crosshair";
	showId ("divDroitePositionne");
	hideId ("divDroiteDefaut");
	hideId ("divGaucheDefaut");
	updateNbInd();
	
	byId("labelNomAgentPos").innerHTML=entById(idEntPlace).nom;
	traceEntites();
}

function modeCrayonPlace () {
	modeOutilPlace="place";
	byId("divCrayonPlace").style.backgroundColor="rgba(255,255,255,1)";
	byId("divCrayonPlace").style.borderColor="rgba(100,100,100,1)";
	
	byId("divGommePlace").style.backgroundColor="rgba(255,255,255,0)";
	byId("divGommePlace").style.borderColor="rgba(100,100,100,0)";
}

function modeGommePlace () {
	modeOutilPlace="efface";
	byId("divCrayonPlace").style.backgroundColor="rgba(255,255,255,0)";
	byId("divCrayonPlace").style.borderColor="rgba(100,100,100,0)";
	
	byId("divGommePlace").style.backgroundColor="rgba(255,255,255,1)";
	byId("divGommePlace").style.borderColor="rgba(100,100,100,1)";
}

function mouseDownDamier (e) {
	damierClic=true;
	let rect = e.target.getBoundingClientRect();
	let x = e.clientX - rect.left;
	let y = e.clientY - rect.top;
	xSurvolDamier=Math.floor(x/lCanv*nbCol);
	ySurvolDamier=Math.floor(y/hCanv*nbLig);
	if (modePlaceEntites===true) {placeDamier(xSurvolDamier,ySurvolDamier);}
	else if (modePlaceZones===true) {placeDamierZone (xSurvolDamier,ySurvolDamier)}
}

function mouseUpDamier (e) {
	damierClic=false;
	if (modePlaceZones==true) {traceZones();}
}

function mouseOutDamier (e) {
	damierClic=false;
	xSurvolDamier=-1;
	ySurvolDamier=-1;
}

function mouseMoveDamier (e) {
	let rect = e.target.getBoundingClientRect();
	let x = e.clientX - rect.left;
	let y = e.clientY - rect.top;
	xSurvolDamier=Math.floor(x/lCanv*nbCol);
	ySurvolDamier=Math.floor(y/hCanv*nbLig);
	if (damierClic===false) {return false;}
	if (modePlaceEntites===true) {placeDamier(xSurvolDamier,ySurvolDamier);}
	else if (modePlaceZones===true) {placeDamierZone (xSurvolDamier,ySurvolDamier)}
}

function clicDamier (e) {
	let rect = e.target.getBoundingClientRect();
	let x = e.clientX - rect.left;
	let y = e.clientY - rect.top;
	xSurvolDamier=Math.floor(x/lCanv*nbCol);
	ySurvolDamier=Math.floor(y/hCanv*nbLig);
	if (modePlaceEntites===true) {placeDamier(xSurvolDamier,ySurvolDamier);}
	else if (modePlaceZones===true) {placeDamierZone (xSurvolDamier,ySurvolDamier)}
	updateEffectifLegende();
}

function placeDamier (x,y) {
	if (xSurvolDamier<0) {return false;}
	
	
	if (modeOutilPlace=="place") {
		if (damier[x][y]==0) { // case libre
			rajouteEnt(idEntPlace,x,y);
		}
	} else if (modeOutilPlace=="efface") {
		if (damier[x][y]==idEntPlace) { // case libre
			destroyEnt(x,y);
		} 
	}
	traceEntites();
	updateNbInd();
}

function updateNbInd () {
	let n=entById(idEntPlace).tInd.length;
	byId("labelNbAgentsPlace").innerHTML=n;
}

function elimineTPlaHorsLimite() {
	for (let e of tEnt) {
		if (e.modePla=="manu") {
			let tPla=e.tPla
			let tPla2=[];
			for (let i=0;i<tPla.length;i+=2) {
				let x=tPla[i];
				let y=tPla[i+1];
				if ((x<nbCol)&&(y<nbLig)) {
					tPla2.push(x);
					tPla2.push(y);
				}
			}
			e.tPla=tPla2.slice();
		}
	}
}

function keyPressDamier (e) {
	if (xSurvolDamier<0) {return false;}
	let idEnt=selectedAgent;
	if (idEnt<0) {return false}
	
	let x=xSurvolDamier;
	let y=ySurvolDamier;
	let code = e.key;
	//console.log (code);
	if (code=="$") {
		if (damier[x][y]==0) {
			rajouteEnt (idEnt,x,y);
			traceEntites();
		}
		
	}
}