var opaZone=50;
var zonesChanged=true;
var modePlaceZones=false;
var selectedZone=-1;
var modeOutilPlaceZ="place";
var tZon=[];
var damierZ=[];
var damierZ0=[];

function clickDefinirZones () {
	selectedZone=-1;
	showId ("divDroiteZones");
	doResetAnim();
	refreshListeZones();
	traceZones();
	modePlaceZones=true;
	selectZone (-1);
	deselOutilsPeintureZ();
	hideId ("divDroiteDefaut");
	hideId ("divGaucheDefaut");
	byId("canvEnv").style.cursor="crosshair";
}

function clickButFinDefinitionZones() {
	damierZ0=JSON.parse(JSON.stringify(damierZ));
	traceZones();
	modePlaceZones=false;
	hideId ("divDroiteZones");
	showId ("divDroiteDefaut");
	showId ("divGaucheDefaut");
	byId("canvEnv").style.cursor="default";
	
	doResetAnim();
}

function initSaisieZone() {
	// couleur aléatoire
	let h=Math.random()*255;
	let s=80;
	let v=80;
	let rgb=hsvToRgb(h, s, v);
	let coulAlea=fullColorHex(rgb[0],rgb[1],rgb[2]);
	byId("inputCoulZone").jscolor.fromString(coulAlea);
	
	showId("divMobile");
	byId("inputNomZone").value="";
	byId("divTitreSaisieZone").innerHTML="<b>Saisie d'une nouvelle zone</b>";
	byId("butSaisieZone").innerHTML="Ajouter cette zone";
	byId("butAnnulerZone").innerHTML="Annuler";
	
	affModale('divSaisieZone');
}

function clickButEditZone() {
	byId("butSaisieZone").innerHTML="Appliquer";
	byId("divTitreSaisieZone").innerHTML="<b>Modification d'une zone</b>";
	byId("butAnnulerZone").innerHTML="Annuler la modification";
	var n=selectedZone;
	if (n<0) {return false}
	var zon=zonById(n);
	byId("inputNomZone").value=zon.nom;
	byId("inputCoulZone").jscolor.fromString(zon.coul);
	affModale('divSaisieZone');
}




function butOKsaisieZone () {
	var nom=byId("inputNomZone").value;
	var couleur=byId("inputCoulZone").jscolor.toHEXString();
	cacheModale();
	var zon={};
	zon.nom=nom;
	zon.coul=couleur;
	hideId("divSaisieZone");
	
	// on regarde la deuxième lettre j comme ajouter
	if (byId("butSaisieZone").innerHTML[1]=="j") { // Ajouter => j
		ajouteZone(zon);
	} else {
		modifieZone(zon);
	}
	traceZones();
}


function modifieZone (zon) {
	zon.id=selectedZone;
	if (zon.nom=="") {
		zon.nom="Zone #"+zon.id;
	}

	var nz=nZonById(selectedZone);
	tZon[nz]=JSON.parse(JSON.stringify(zon));
	tZon[nz].id=zon.id;
	refreshListeZones();
}

function clicRetraitZone() {
	var zon=zonById(selectedZone);
	swal({
		  title: 'Suppression',
		  text: "Etes vous sûr de vouloir supprimer la zone nommée "+zon.nom+" ?",
		  type: 'warning',
		  showCancelButton: true,
		  confirmButtonColor: '#3085d6',
		  cancelButtonColor: '#d33',
		  confirmButtonText: 'Oui',
		  cancelButtonText: 'Non',
		  confirmButtonClass: 'btn btn-success',
		  cancelButtonClass: 'btn btn-danger',
		  buttonsStyling: true,
		  reverseButtons: false
		}).then((result) => {
		  if (result.value) {
			doRemoveZone(selectedZone);
		  } else {
			return false;
		  }
	})
}

function doRemoveZone (id) {
	eraseAllZone(id);
	traceZones();
	tZon.splice(nZonById(id),1);
	selectZone(-1);
	deselOutilsPeintureZ();
	refreshListeZones();
	// on remplace la zone par -1 dans les comportements
	for (c of tCpt) {
		if (c.zone==id) {c.zone=-1}
		if (c.zone2==id) {c.zone2=-1}
	}
		// on remplace la zone par -1 dans les entités
	for (e of tEnt) {
		if (e.zoneDep==id) {e.zoneDep=-1}
		if (e.zoneInit==id) {e.zoneInit=-1}
	}
	damierZ0=JSON.parse(JSON.stringify(damierZ));
	doResetAnim();
}

function ajouteZone(zon) {
	zon.id=trouveIdLibreZon();
	
	if (zon.nom=="") {
		zon.nom="Zone #"+zon.id;
	}
	
	tZon.push(zon);
	refreshListeZones();
	selectZone(zon.id);
}

function refreshListeZonesAut() {
	var sel=byId("selectZoneAut");
	sel.length=0;
	
	var sel2=byId("selectZoneInit");
	sel2.length=0;
	
	var option = document.createElement("option");
	option.text="(n'importe quelle zone)";
	option.value=-1;
	sel.add(option);
	
	var option = document.createElement("option");
	option.text="(n'importe quelle zone)";
	option.value=-1;
	sel2.add(option);
	
	var option = document.createElement("option");
	option.text="(zone non affectée)";
	option.value=0;
	sel.add(option);
	
	var option = document.createElement("option");
	option.text="(zone non affectée)";
	option.value=0;
	sel2.add(option);
		
	for (let i=0;i<tZon.length;i++) {
		let e=tZon[i];
		
		var option = document.createElement("option");
		option.text=e.nom;
		option.value=e.id;
		sel.add(option);
		
		var option = document.createElement("option");
		option.text=e.nom;
		option.value=e.id;
		sel2.add(option);
	}
}

function refreshListeZonesCpt() {
	var sel=byId("selectTypeZoneCpt");
	var sel2=byId("selectTypeZoneCpt2");
	sel.length=0;
	sel2.length=0;
	
	var option = document.createElement("option");
	option.text="(n'importe quelle zone)";
	option.value=-1;
	sel.add(option);
	
	var option2 = document.createElement("option");
	option2.text="(aucun changement)";
	option2.value=-1;
	sel2.add(option2);
	
	var option = document.createElement("option");
	option.text="(zone non affectée)";
	option.value=0;
	sel.add(option);
	
	var option2 = document.createElement("option");
	option2.text="(zone non affectée)";
	option2.value=0;
	sel2.add(option2);
	
	for (let i=0;i<tZon.length;i++) {
		let e=tZon[i];
		
		var option = document.createElement("option");
		option.text=e.nom;
		option.value=e.id;
		sel.add(option);
		
		var option2 = document.createElement("option");
		option2.text=e.nom;
		option2.value=e.id;
		sel2.add(option2);
	}
}

function refreshListeZones() {
	var d=byId("divListeZones");
	var t="";
	
	t+="<div id=\"spanListeZon"+0+"\" style=\"cursor:pointer;padding-left:0.2em;width:100%;\" ";
	t+="onclick=\"selectZone("+0+")\" ";
	t+="ondblclick=\"clickButEditZone()\" "
	t+=">";
	t+="<div style='display:inline-block;border:1px solid black;width:0.7em;height:0.7em;background-color:white'></div>&nbsp;";
	t+="(zone non affectée/vide)"+"</div>";
		
	for (let i=0;i<tZon.length;i++) {
		let e=tZon[i];
			
		t+="<div id=\"spanListeZon"+e.id+"\" style=\"cursor:pointer;padding-left:0.2em;width:100%;\" ";
		t+="onclick=\"selectZone("+e.id+")\" ";
		t+="ondblclick=\"clickButEditZone()\" "
		t+=">";
		t+="<div style='display:inline-block;border:1px solid black;width:0.7em;height:0.7em;background-color:"+e.coul+"'></div>&nbsp;";
		t+=e.nom+"</div>";
	}
	d.innerHTML=t;
	selectZone(selectedZone);
	refreshListeZonesCpt();	
}


function selectZone(id) {
	effaceSelZone();
	selectedZone=id;
	recalcOpaOutilsPeintureZ();
	recalcOpaMenuZones();
	if (id>=0) {
		let s=byId ("spanListeZon"+id);
		s.style.backgroundColor="#666";
		s.style.color="white";
	} 
}

function effaceSelZone () {
	let s=byId ("spanListeZon"+0);
	s.style.backgroundColor="white";
	s.style.color="black";
	for (e of tZon) {
		let s=byId ("spanListeZon"+e.id);
		s.style.backgroundColor="white";
		s.style.color="black";
	}
}

function recalcOpaOutilsPeintureZ() {
	let opa=1;
	let cur="pointer";
	if (selectedZone<0) {opa=0.3;cur="default";}
	byId("divCrayonPlaceZ").style.opacity=opa;
	byId("divCrayonPlaceZ").style.cursor=cur;
	byId("divGommePlaceZ").style.opacity=opa;
	byId("divGommePlaceZ").style.cursor=cur;
	byId("divPeintureZ").style.opacity=opa;
	byId("divPeintureZ").style.cursor=cur;
	if (selectedZone<=0) {opa=0.3;cur="default";}
	byId("divBrossePlaceZ").style.opacity=opa;
	byId("divBrossePlaceZ").style.cursor=cur;
}

function recalcOpaMenuZones () {
	let opa=1;
	let cur="pointer";
	if (selectedZone<=0) {opa=0.3;cur="default";}
	byId("divMenuEditZone").style.opacity=opa;
	byId("divMenuEditZone").style.cursor=cur;
	byId("divMenuSupprZone").style.opacity=opa;
	byId("divMenuSupprZone").style.cursor=cur;
}

function deselOutilsPeintureZ () {
	modeOutilPlaceZ="";
	recalcOpaOutilsPeintureZ();
	
	byId("divCrayonPlaceZ").style.backgroundColor="rgba(255,255,255,0)";
	byId("divCrayonPlaceZ").style.borderColor="rgba(100,100,100,0)";
	
	byId("divGommePlaceZ").style.backgroundColor="rgba(255,255,255,0)";
	byId("divGommePlaceZ").style.borderColor="rgba(100,100,100,0)";
	
	byId("divPeintureZ").style.backgroundColor="rgba(255,255,255,0)";
	byId("divPeintureZ").style.borderColor="rgba(100,100,100,0)";
}

function modePeintureZ () {
	if (selectedZone<0) {return false;}
	deselOutilsPeintureZ ();
	modeOutilPlaceZ="peinture";
	byId("divPeintureZ").style.backgroundColor="rgba(255,255,255,1)";
	byId("divPeintureZ").style.borderColor="rgba(100,100,100,1)";
}


function modeCrayonPlaceZ () {
	if (selectedZone<0) {return false;}
	deselOutilsPeintureZ ();
	modeOutilPlaceZ="place";
	byId("divCrayonPlaceZ").style.backgroundColor="rgba(255,255,255,1)";
	byId("divCrayonPlaceZ").style.borderColor="rgba(100,100,100,1)";
}

function modeGommePlaceZ () {
	if (selectedZone<0) {return false;}
	deselOutilsPeintureZ ();	
	modeOutilPlaceZ="efface";
	byId("divGommePlaceZ").style.backgroundColor="rgba(255,255,255,1)";
	byId("divGommePlaceZ").style.borderColor="rgba(100,100,100,1)";
}

function clickButBrosseZones() {
	if (selectedZone<=0) {return false;}
	swal({
		  title: 'Suppression de toutes les zones de type \"'+zonById(selectedZone).nom+'\"',
		  text: "Etes vous sûr de vouloir supprimer tous les agents de type \""+zonById(selectedZone).nom+"\" ?",
		  type: 'warning',
		  showCancelButton: true,
		  confirmButtonColor: '#3085d6',
		  cancelButtonColor: '#d33',
		  confirmButtonText: 'Oui',
		  cancelButtonText: 'Non',
		  confirmButtonClass: 'btn btn-success',
		  cancelButtonClass: 'btn btn-danger',
		  buttonsStyling: true,
		  reverseButtons: false
		}).then((result) => {
		  if (result.value) {
			  eraseAllZone (selectedZone);
			  traceZones();
		  } else {
			return false;
		  }
	})
}

function eraseAllZone(z) {
	for (let c=0;c<nbCol;c++) {
		for (let l=0;l<nbLig;l++) {
			if (damierZ[c][l]==z) {
				damierZ[c][l]=0;
			}
		}
	}
}

function placeDamierZone (x,y) {
	if (xSurvolDamier<0) {return false;}
	if (selectedZone<0) {return false;}
	
	if (modeOutilPlaceZ=="place") {
		damierZ[x][y]=selectedZone;
		traceCaseZone (x,y);
	} else if (modeOutilPlaceZ=="efface") {
		damierZ[x][y]=0;
		traceCaseZone (x,y);
	} else if (modeOutilPlaceZ=="peinture") {
		if (selectedZone!=damierZ[x][y]) {
			bucketPaint (x,y,damierZ[x][y]);
		}
		traceZones();
	}
}

function bucketPaint (x,y,c) {
	if ((x<0)||(x>=nbCol)||(y<0)||(y>nbLig)) {return false}
	if (damierZ[x][y]!=c) {return false}
	damierZ[x][y]=selectedZone;
	bucketPaint (x-1,y,c);
	bucketPaint (x+1,y,c);
	bucketPaint (x,y-1,c);
	bucketPaint (x,y+1,c);
}

function traceZones() {
	byId("canvZones").style.opacity=opaZone/100;
	if (tZon.length==0) {return false;}
	var canv=byId("canvZones");
	var ctx=canv.getContext('2d');
	ctx.clearRect(0,0,lCanv,hCanv);
	
	let r=lCanv/nbCol+0.5;
	
	for (let c=0;c<nbCol;c++) {
		for (let l=0;l<nbLig;l++) {
			let d=damierZ[c][l];
			if (d>0) {
				let x=c/nbCol*lCanv-0.25;
				let y=l/nbLig*hCanv-0.25;			
				ctx.fillStyle=zonById(d).coul;
				ctx.fillRect(x,y,r,r);
			}
		}
	}
	
	zonesChanged=false;
}

function traceCaseZone (c,l) {
	var canv=byId("canvZones");
	var ctx=canv.getContext('2d');
	
	let d=damierZ[c][l];
	let r=lCanv/nbCol+0.5;
	let x=c/nbCol*lCanv-0.25;
	let y=l/nbLig*hCanv-0.25;			
	
	if (d>0) {
		ctx.fillStyle=zonById(d).coul;
		ctx.fillRect(x,y,r,r);
	} else {
		ctx.clearRect(x,y,r,r);
	}
}



function zonById(id) {
	var ent = tZon.find(obj => {
	  return obj.id === id
	})
	return ent;
}

function nZonById (id) {
	var nEnt = tZon.findIndex(obj => {
	  return obj.id === id
	})
	return nEnt;
}

function trouveIdLibreZon () {
	var id=0;
	var trouve=-1;
	do {
		id++;
		trouve=tZon.findIndex(x => x.id === id);
	} while (trouve>=0) 
	return id;
}

function calcSurfaceZone (id) {
	let n=0;
	for (let dam of damierZ) {
		n+=dam.filter(c=>(c==id)).length;
	}
	return n;
}
