var tLien = new Array ();
tLien[0]=null;

var idLienEnEdition;

var mobile=false;
var idMobile="00";


function creeLien (idV1,idV2,coul) {
	
	var o=new Object();
	var nouvDiv=true;
	var n=0;
	var i=0;
	// on cherche un slot de libre
	while ((nouvDiv)&&(i<(tLien.length-1))) {
		i++;
		if (tLien[i].suppr===true) {
			nouvDiv=false;
			n=i;
		}
	} 
	
	if (nouvDiv==true) {n=tLien.length;}
	
	var nId=n;
	var id=to2digits(nId);
	o.typeRel="taux";
	o.actif=true;
	o.delai=0;
	o.suppr=false;
	o.idV1=idV1;
	o.idV2=idV2;
	o.coul=coul;
	o.autoCoul=true;
	tLien[nId]=o;
	
	creePath (id,coul,nouvDiv);
	return id;
}

function clicESdroit (sender) {
	var idsender=sender.parentNode.getAttribute("id");
	var id=idsender.substr(3,2);
	
	var noeudMobile=byId("noeud_mobile");
	var divVar=byId("var"+id);
	var es_out=divVar.getElementsByClassName("es_droit")[0];
	
	var rect_out=es_out.getBoundingClientRect();
	var rect_mob=noeudMobile.getBoundingClientRect();
	
	var x=Math.round(rect_out.left+rect_out.right)/2;
	var y=Math.round(rect_out.top+rect_out.bottom)/2;
	var l=Math.round(-rect_mob.left+rect_mob.right);
	var h=Math.round(-rect_mob.top+rect_mob.bottom);

	noeudMobile.style.left=Math.round(x-l/2)+"px";
	noeudMobile.style.top=Math.round(y-h/2)+"px";
	
	idMobile=id;	
	startDragMobile();
}

function upESgauche (sender) {
	if (!mobile) {return false;}
	let idsender=sender.parentNode.getAttribute("id");
	let id1=idMobile;
	let id2=idsender.substr(3,2);
	let nId1=id1*1;
	let nId2=id2*1;
	let v1=tVar[nId1]; // variable source
	let v2=tVar[nId2]; // variable cible
	stopDragMobile();
	
	// erreurs de manip
	if (v2.typeVar=="c") {
		swal({
		  type: 'error',
		  title: 'Erreur de manipulation',
		  text: 'Il est impossible de créer manuellement un lien vers une variable calculée'
		})
		return false;
	}
	
	if (
		(v1.typeVar=="p")&&
		((v2.typeVar=="c")||(v2.typeVar=="d"))
	) {
		swal({
		  type: 'error',
		  title: 'Erreur de manipulation',
		  text: 'Il est impossible de créer un lien provenant d\'un phénomène vers une variable'
		})
		return false;
	}
	
	// type de lien en fonction de v2
	var idLienCree;
	if (v2.typeVar=="v") {
		// lien vers une variable dérivée
		creeLienDeri(id1,id2);		
	} 
	
	else if (v2.typeVar=="d") {
		// lien vers une variable dynamique
		idLienCree=creeLien (id1, id2,"666666");
		tLien[idLienCree*1].selType="aug";
		tLien[idLienCree*1].pente=0.01;
		tLien[idLienCree*1].seuil=0;
		tLien[idLienCree*1].seuilneg=false;
		tLien[idLienCree*1].formule=tLien[idLienCree*1].pente+"*x";
		afficheEditorLien (idLienCree);
	}
	
	else if (v2.typeVar=="p") {
		// lien vers un phénomène
		idLienCree=creeLien (id1, id2,"666666");
		tLien[idLienCree*1].typeRel="pheno";
		tLien[idLienCree*1].seuil=0;
		tLien[idLienCree*1].seuilType="sup";
		if (v1.typeVar=="p") {
			// lien de pheno à pheno
			tLien[idLienCree*1].seuil=0.5;
		}
		afficheEditorLien (idLienCree);
	}
}

function startDragMobile () {
	showId("noeud_mobile");
	mobile=true;
}

function stopDragMobile () {
	hideId("noeud_mobile");
	hideId("path00");
	mobile=false;
}


function bougeMobile (event) {
	var noeudMobile=byId("noeud_mobile");	
	var rect_mob=noeudMobile.getBoundingClientRect();
	var l=Math.round(-rect_mob.left+rect_mob.right);
	var h=Math.round(-rect_mob.top+rect_mob.bottom);
	
	var x = event.clientX;     
	var y = event.clientY;
	 
	noeudMobile.style.left=Math.round(x-l/2)+"px";
	noeudMobile.style.top=Math.round(y-h/2)+"px";
	
	updatePathMobile();
}

function to2digits (n) {
	var t="";
	if (n<10) {t="0";}
	return t+""+n;
}

function checkCoulAuto (ch) {
	tLien[idLienEnEdition*1].autoCoul=ch;
	if (ch) {
		hideId("editor_lien_coul");
	} else {
		showId("editor_lien_coul");
	}
}

function dblClickLien (sender) {
	closeMenu();
	var id=sender.getAttribute("id").substr(3,2);
	if (tLien[id*1].typeRel=="der") {
		swal({
		  type: 'error',
		  title: 'Erreur de manipulation',
		  text: 'Il est impossible de modifier un lien vers une variable dérivée'
		})
		return false;	
	}
	idLienEnEdition=id;
	afficheEditorLien (id);
}

function afficheEditorLien (id) {
	// on affiche tous les éditeurs afin de les mettre à jour
	showId("div_editor_lien");
	showId('editor_lien_secretion_dynamique');
	showId('editor_lien_phenomene');
	showId('div_seuil_pheno');
	showId('div_pheno_pheno');

	initDivGraphEffet();
		
	idLienEnEdition=id;
	var nId=id*1;
	var lien=tLien[nId];
	var i1=lien.idV1*1;
	var i2=lien.idV2*1;
	var v1=tVar[i1];
	var v2=tVar[i2];
	if (lien.actif) {byId("but_act_lien").innerHTML="Désactiver";} else {byId("but_act_lien").innerHTML="Activer";}
	
	// On adapte le vocabulaire en fonction de la première variable
	adaptVoca(v1.voc);
		
	
	byId("label_n_rel").innerHTML=id;
	byId("lien_select_type").value=v1.selType;
	byId("label_lien_var1").innerHTML=v1.nom;
	byId("label_lien_var1for").innerHTML=v1.nom;
	byId("label_lien_var2for").innerHTML=v2.nom;
	byId("label_lien_seuil_var1").innerHTML=v1.nom;
	byId("label_lien_seuil_var1b").innerHTML=v1.nom;
	byId("label_lien_var1eff").innerHTML=v1.nom;
	byId("label_lien_var2eff").innerHTML=v2.nom;
	byId("label_lien_var2").innerHTML=v2.nom;
	
	byId("input_pente").value=lien.pente;
	byId("input_delai").value=lien.delai;
	byId('input_seuil').value=lien.seuil;
	byId('input_seuil2').value=lien.seuil;
	byId('check_neg_seuil').checked=lien.seuilneg;
	byId("check_coul_auto").checked=lien.autoCoul;
	byId("lien_select_type").value=lien.selType;
	byId("lien_select_seuil_type").value=lien.seuilType;
	byId("lien_select_seuil_type2").value=lien.seuilType;
	showId('editor_lien_coul');
	var coul=lien.coul;
	byId("input_couleur_lien").jscolor.fromString(coul);
	if (lien.autoCoul) {hideId('editor_lien_coul');} 
	updateFormule ();

	// on affiche uniquement l'éditeur correspondant à la variable 2
	hideId('editor_lien_secretion_dynamique');
	hideId('editor_lien_phenomene');
	hideId('but_suppr_lien');
	hideId('but_act_lien');
	hideId('editor_lien_influence_calc');
	hideId('div_seuil_pheno');
	hideId('div_pheno_pheno');

	
	if (v2.typeVar=="c") {
		showId('editor_lien_influence_calc');
	} else {
		showId('but_suppr_lien');
		showId('but_act_lien');
	}
	
	
	if (lien.typeRel=="pheno") {
		showId('editor_lien_phenomene');
		if (v1.typeVar=="p") {
			showId('div_pheno_pheno');
		} else {
			showId('div_seuil_pheno');
		}
	}
	
	if (lien.typeRel=="taux") {
		showId('editor_lien_secretion_dynamique');
	} 
}

function fermeEditorLien () {
	var lien=tLien[idLienEnEdition*1];
	var i1=lien.idV1*1;
	var i2=lien.idV2*1;
	var v1=tVar[i1];
	var v2=tVar[i2];
	updateFormule();
	var coul=byId("input_couleur_lien").value;
	var selType=byId("lien_select_type").value;
	var pente=byId("input_pente").value*1;
	var formule=byId("label_formule").innerHTML;
	
	byId('path'+idLienEnEdition).setAttribute('stroke',"#"+coul);
	lien.coul=coul;
	lien.selType=selType;
	lien.pente=pente;
	lien.delai=byId("input_delai").value*1;
	lien.formule=formule;
	
	if (lien.typeRel=="pheno") {
		
		if (v1.typeVar=="p") {
			// lien phenopheno
			lien.seuilType=byId("lien_select_seuil_type2").value;			
		} else {
			lien.seuil=byId('input_seuil2').value;
			lien.seuilType=byId("lien_select_seuil_type").value;
		}
	} else {
		lien.seuil=byId('input_seuil').value;
	}
	
	lien.seuilneg=byId('check_neg_seuil').checked;
	
	hideId("div_editor_lien");
	
	updateSVG(idLienEnEdition);
}

function supprLiensSauf(idv,idl) {
	//on supprime tout lien pointant vers la variable idv, sauf le lien idl
	for (var i=1;i<tLien.length;i++) {
		var lien=tLien[i];
		var id=to2digits(i);
		if ((id!=idl)&&(lien.idV2==idv)) { 
			supprLien(id);
		}
	}
}

function supprLiensVers(idv) {
	//on supprime tout lien pointant vers la variable idv
	for (var i=1;i<tLien.length;i++) {
		var lien=tLien[i];
		if (lien.idV2==idv) { 
			supprLien(to2digits(i));
		}
	}
}


function activateLien(id) {
	var act=!tLien[id*1].actif;
	
	tLien[id*1].actif=act;
	var ctrc=byId("ctr"+id);
	var courbe=byId("path"+id);
	if (act) {
		ctrc.style.backgroundImage = "url('images/triangleCercle.png')";
		courbe.setAttribute("stroke-opacity",0.9);
	} else {
		ctrc.style.backgroundImage = "url('images/circleX.png')";
		courbe.setAttribute("stroke-opacity",0.1);
	}
}

function supprLien (id) {
	tLien[id*1].suppr=true;
	tLien[id*1].actif=false;
	hideId("path"+id);
	hideId("ctr"+id);
	hideId("div_editor_lien");
}


function updateFormule () {
	var pente=byId('input_pente').value*1;
	var seuil=byId('input_seuil').value*1;
	var b=-pente*seuil;
	var selType=byId("lien_select_type").value;
	var formule1="";
	var formule2="";
	if (selType=="dim") {
		formule1="-";
	}
	
	if (b!=0){
		if (selType=="aug") {
			formule2=b;
		} else {
			formule2=-b;
		}
		if (formule2>0) {formule2="+"+formule2;}
	}
	
	
	var formule=formule1+pente+"*x"+formule2;
	byId("label_formule").innerHTML=formule;
	
	traceEffet();
}

function compteLiensVersVar (id) {
	// on compte les liens actifs et non supprimés vers la variable id
	var nId=id*1;
	id=to2digits(nId);
	var n=0;
	for (var i=1;i<tLien.length;i++) {
		var lien=tLien[i];
		var idV1=tLien[i].idV1;
		if ((lien.actif)&&(tVar[idV1*1].actif)) {
			if (lien.idV2==id) {n++;}
		}
	}
	return n;
}

function compteLiensActivantPheno (id) {
	// on compte les liens actifs et non supprimés activant le phénomène id
	var nId=id*1;
	id=to2digits(nId);
	var n=0;
	for (var i=1;i<tLien.length;i++) {
		var lien=tLien[i];
		var delai=lien.delai;
		if (lien.actif) {
			if (lien.idV2==id) {
				// on vérifie si le lien i active le phénomène 
				
				var idV1=lien.idV1;
				if (tVar[idV1*1].actif) { // il faut que la variable soit active
					var seuil=lien.seuil;
					var x=valDecal(idV1*1,delai);
					if (lien.seuilType=="sup") {
						if (x>seuil) {n++;}
					} else {
						if (x<seuil) {n++;}
					}
				}
				
			}
		}
	}
	return n;
}

