function ajoutVarCalc () {
	var id=creeDivVar();
	var nId=id*1;
	tVar[nId].typeVar="c";
	tVar[nId].nom="variable calc.#"+id;
	adapteTypeVar(id);
	closeMenu();
	restart();
}

function updateListeVar () {
	var t="";
	t+="<p>t => ";
				t+="<b>temps</b>";
				t+=" = "+sigFigs((iTemps*deltaT/1000),nbSig)+" s";
				t+="</p>";
	var v2=returnArrV(idVarEnEdition);
	for (var i=1;i<tVar.length;i++) {
		var v=tVar[i];
		var id=to2digits(i);

		if ((!v.suppr)&&(id!=idVarEnEdition)) {
			if ((v.typeVar=="d")||(v.typeVar=="c")||(v.typeVar=="p")||(v.typeVar=="n")||(v.typeVar=="v")) {
				t+="<p>v["+i+"] => ";
				t+="<b>"+v.nom+"</b>";
				t+=" = "+sigFigs(v2[i-1],nbSig)+" ";
				if (v.typeVar!="p") {t+=v.units;}
				t+="</p>";
			}
		}
	}
	byId("div_liste_var").innerHTML=t;
}

function valDecal (nId,t) {
	var d=Math.round(t*1000/deltaT);
	var tv=tVar[nId];
	if (tv.suppr===true) {return false;}
	if (d==0) {
		if (tv.nullVal) {return 0;} else {return tv.val;}
	}
	var ii=iTemps-d;
	if (ii<0) {return tv.val0;}
	ii=ii%nbMaxVal;
	return tg[nId].graph[ii];
}

function returnArrV (id) {
	// b true => valeurs
	// b false => dérivées
	var nId=id*1;
	var tv=new Array();
	var tDelai=[0];
	
	// on recueille les délais
	for (var i=1;i<tVar.length;i++) {
		// on vérifie si un lien venant de cette variable pointe sur id et a un délai >0
		var delai=0;
		var idV1=to2digits(i);
		for (var j=1;j<tLien.length;j++) {
			var lien=tLien[j];
			if (!lien.suppr) {
				if (((lien.idV1)==idV1)&&(lien.idV2==id)) {
					delai=lien.delai;
				}
			}
		}
		tDelai[i]=delai*1;
	}
	
	var a;
	tv[0]=0;
	for (var i=1;i<tVar.length;i++) {
		a=valDecal(i,tDelai[i]);
		tv[i-1]=a*1; 
		// on décale de 1 car le scope de math.eval commence à [1]
		// ainsi v[0] une fois dans scope sera interprété comme v[1]
	}
		
	
	return tv;
}

function recalcEvalVarCalc () {
	var div=byId("text_formule_var_calc");
	var formule=div.value;
	var labelEval=byId("label_eval_var_calc");
	var y=evalFormuleVarCalc (idVarEnEdition,formule);
	if (isNaN(y)) {
		labelEval.innerHTML=y;
	} else {
		labelEval.innerHTML=sigFigs(y,nbSig);
	}
}

function evalFormuleVarCalc (id,formule) {
	var v=new Array();

	v=returnArrV(id);
	
	var y;
	var scope={v:v,t:(iTemps*deltaT/1000)};
	
	//on remplace "alea" par "random()"
	formule=formule.replace("alea","random()");
	
	
	try {
		y=math.eval(formule,scope)*1; 
	} catch (e) {
		y="erreur";
	}

	return y;
}

function updateCalcVar (id) {
	var nId=id*1;
	var v=tVar[nId];
	if (v.typeVar!="c") {return false;}
	
	var formule=v.formCalc;
	var y=evalFormuleVarCalc (id,formule);
	
	if (v.typeCalc=="t") {
		// le taux est calculé et la valeur augmentée du taux
		tVar[nId].val+=y*deltaT/1000;
		
	} else {
		// la valeur est calculé directement
		tVar[nId].val=y*1;	
	}	
}

function creeLiensDansFormule (id) {
	var nId=id*1;
	if (tVar[nId].typeVar!="c") {return false;}
	
	var idV2=to2digits(nId);
	var formule=tVar[nId].formCalc;
	for (var i=1;i<tVar.length;i++) {
		if ((i!=nId)&&(!tVar[i].suppr)) {
			if (nvarEstDansFormule(i,formule)) {
				var idV1=to2digits(i);
				var idCree=creeLien (idV1,idV2,"AAAAAA");
				tLien[idCree*1].typeRel="calc";
			}
		}
	}
}

function nvarEstDansFormule (n,formule) {
	var varExpr="v["+n+"]";
	return formule.indexOf(varExpr) !== -1;;
}

function changeVarCalcType (v) {
	if (v=="t") {txtInClass("_dydt","dy/dt");} else {txtInClass("_dydt","y");}
}


function updateAllVarCalc () {
	// update des variables calculées
	for (var j=1;j<tVar.length;j++) {
		if ((tVar[j].actif)&&(j!=modifyingVar)&&(tVar[j].typeVar=="c")) {
			updateCalcVar(j);
			checkRange(j);
		}
	}
}