var selectedAgent=-1;
var nbMaxInd=0;
var tEnt=[];
var tImageEnt=[];
var legendeEntVisible=true;
var afficheEff=true;


function griseDiv (d,g) {
	d=byId(d);
	if (d===null) {return false;}
	if (g===true) {
		d.style.opacity=1;
		d.style.pointerEvents="auto";
	} else {
		d.style.opacity=0.5;
		d.style.pointerEvents="none";
	}
}

function effaceSelAgent () {
	for (e of tEnt) {
		let s=byId ("spanListeEnt"+e.id);
		s.style.backgroundColor="white";
		s.style.color="black";
	}
}

function selectAgent(id) {
	effaceSelAgent();
	selectedAgent=id;
	
	griseDiv("divIntroduitEntite",false);
	griseDiv("divDepeupleEntite",false);
	griseDiv("divPlaceEntite",false);
	griseDiv("divEditEntite",true);
	griseDiv("divSupprEntite",true);
	
	if (id>=0) {
		let s=byId ("spanListeEnt"+id);
		s.style.backgroundColor="#666";
		s.style.color="white";
		if (entById(id).tInd.length>0) {
			griseDiv("divDepeupleEntite",true);	
		}
		if (entById(id).modePla=="auto") {
			griseDiv("divIntroduitEntite",true);
		} else {
			griseDiv("divPlaceEntite",true);
		}
	} else {
		griseDiv("divEditEntite",false);
		griseDiv("divSupprEntite",false);
	}
}

function dblClickEntite() {
	clickButEditEntite();
}

function clickButDupliquerEntite () {
	let  n=selectedAgent;
	if (n<0) {return false}
	let ent=JSON.parse(JSON.stringify(entById(n))); // on deep-clone l'entité
	// attribution d'un nom unique
	let maxl=inputNomEntite.maxLength;
	let nn=1;
	let nom=ent.nom;
	while (tEnt.some(c=>c.nom==nom)) {
		nn++;
		let suffixe="#"+nn;
		nom=ent.nom+suffixe;
		if (nom.length>maxl) { // nom plus long que le champ de saisie
			nom=nom.substr(0,maxl-suffixe.length)+suffixe;		
		}
	}
	ent.nom=nom;
	ajouteEntite(ent);
}

function clicCheckMobile(c) {
	if (c) {
		showId("divMobile");
	} else {
		hideId("divMobile");		
	}	
}


function toggleButFormule () {
	let isExpr=(butFormule.style.outlineColor=="black");
	if (!isExpr) {
		butFormule.style.outlineColor="black"
	} else {
		butFormule.style.outlineColor="rgba(0,0,0,0)"
	}
	
	hideFieldsIfExpr();
}

function hideFieldsIfExpr() {
	let isExpr=(butFormule.style.outlineColor=="black");
	griseDiv("inputNbEntites",!isExpr);
	griseDiv("divPlacement",!isExpr);
	griseDiv("divDemiVie",!isExpr);
	griseDiv("divCadreMobile",!isExpr);
	griseDiv("spanNbAgents",!isExpr);
	griseDiv("divApparence",!isExpr);
	if (isExpr) {
		show(inputExpr);
	} else {
		hide(inputExpr);
	}
}


function selectModePlacementChange () {
	let v=byId("selectModePlacement").value;
	if (v=="auto") {
		showId("saisieEntitePlaceAuto");
		inputNbEntites.value=0;
	} else {
		hideId("saisieEntitePlaceAuto");
	}
}

function clickButEditEntite() {
	butSaisieEntite.innerHTML="Appliquer";
	divTitreSaisieAgent.innerHTML="<b>Modification d'un agent</b>";
	butAnnulerEntite.innerHTML="Annuler la modification";
	let  n=selectedAgent;
	if (n<0) {return false}
	let ent=entById(n);
	selectApparenceEntite.value=ent.forme;
	
	if (ent.forme=="image") {
		divChangeImage.style.display="inline-block";
	} else {
		hideId("divChangeImage");
	}
	
	if (typeof(ent.expr)!="undefined") {
		butFormule.style.outlineColor="black";
		inputExpr.value=ent.expr;
	} else {
		butFormule.style.outlineColor="rgba(0,0,0,0)";
		inputExpr.value="";
	}
	hideFieldsIfExpr();
	
	if (ent.forme=="carac") {
		showId("divChoixCaractere");
		inputCaract.value=ent.car;
	} else {
		hideId("divChoixCaractere");
	}
	inputDemiVie.value=ent.dvie;
	inputNomEntite.value=ent.nom;
	checkEntDeplace.checked=ent.mobile;
	if (ent.mobile===true) {
		showId("divMobile");
	} else {
		hideId("divMobile");		
	}
	inputVitesseEnt.value=ent.vitesse;
	inputCoulEntite.jscolor.fromString(ent.coul);
	imageFileApi.value = "";
	selectModePlacement.value=ent.modePla;
	selectModePlacementChange();
	affModale('divSaisieEntite');
	inputNbEntites.value=ent.nbInd;
	if (tZon.length==0) {
		hideId("divZoneDepl");
		hideId("divZoneInit");
	} else {
		showId("divZoneDepl");
		showId("divZoneInit");
	}
	refreshListeZonesAut();
	selectZoneAut.value=ent.zoneDep;
	selectZoneInit.value=ent.zoneInit;
}

function butOKsaisieEntite () {
	showId("divPatience");
	setTimeout (butOKsaisieEntite2,10);
}


function butOKsaisieEntite2 () {
	var forme=byId("selectApparenceEntite").value;
	var nom=byId("inputNomEntite").value;
	var nbInd=byId("inputNbEntites").value*1;
	var mobile=byId("checkEntDeplace").checked;
	var vitesse=byId("inputVitesseEnt").value*1;
	var couleur=byId("inputCoulEntite").jscolor.toHEXString();
	var dvie=byId("inputDemiVie").value*1;
	var modePla=byId("selectModePlacement").value;
	let isExpr=(butFormule.style.outlineColor=="black");
	var nbMax=(nbLig*nbCol);
	cacheModale();
	var ent={};
	nbInd=Math.min(nbMax,nbInd);
	if (!isExpr) {delete ent.expr} 
	else {
		if (inputExpr.value=="") {
			ent.expr=0;
		} else {
			ent.expr=inputExpr.value;
		}
		nbInd=0;
	}
	ent.nbInd=nbInd;
	ent.mobile=mobile;
	ent.nom=nom;
	ent.dir="";
	if (checkUp.checked) {ent.dir+="1"} else {ent.dir+="0"}
	if (checkRight.checked) {ent.dir+="1"} else {ent.dir+="0"}
	if (checkDown.checked) {ent.dir+="1"} else {ent.dir+="0"}
	if (checkLeft.checked) {ent.dir+="1"} else {ent.dir+="0"}
	ent.dvie=dvie;
	ent.tInd=[];
	ent.vitesse=vitesse;
	ent.forme=forme;
	ent.coul=couleur;
	ent.modePla=modePla;
	ent.zoneDep=byId("selectZoneAut").value*1;
	ent.zoneInit=byId("selectZoneInit").value*1;
	
	if (ent.forme=="carac") {
		ent.car=byId("inputCaract").value;
		if (ent.car=="") {ent.car="#"}
	}
	
	if (forme=="image") {
		if (byId("imageFileApi").value!="") {
			var png64=byId("canvTemp64").toDataURL();
			ent.png64=png64;
		} else {
			if (selectedAgent<0) {
				ent.png64="";
			}
			else if (typeof (entById(selectedAgent).png64)==="undefined") {
				ent.png64="";
			} else {
				ent.png64=entById(selectedAgent).png64;
			}
		}
	}	
	hideId("divSaisieEntite");
	
	// on regarde la première lettre A comme ajouter
	if (byId("butSaisieEntite").innerHTML[1]=="j") { // Ajouter => j
		ent.onGraph=true;
		ajouteEntite(ent);
	} else {
		ent.onGraph=entById(selectedAgent).onGraph;
		modifieEntite(ent);
	}
	
	doResetAnim();
	
	hideId("divPatience");
}


function modifieEntite (ent) {
	ent.id=selectedAgent;
	if (ent.nom=="") {
		ent.nom="Agent #"+ent.id;
	}
	if (ent.modePla=="manu") {
		ent.nbInd=-1;
		ent.tPla=entById(selectedAgent).tPla||[];
	}
	var ne=nEntById(selectedAgent);
	tEnt[ne]=JSON.parse(JSON.stringify(ent));
	tEnt[ne].id=ent.id;
	updateAfterChangeEntites();
}

function clicDepeupleEntite () {
	var ent=tEnt[nEntById(selectedAgent)];
	for (let ind of ent.tInd) {
		damier [ind.x][ind.y]=0;
	}
	tEnt[nEntById(selectedAgent)].tInd=[];
	traceEntites();
	selectAgent(selectedAgent);
}

function clicRetraitEnt() {
	var ent=entById(selectedAgent);
	swal({
		  title: 'Suppression',
		  text: "Etes vous sûr de vouloir supprimer l'agent nommé "+ent.nom+" ?",
		  type: 'warning',
		  showCancelButton: true,
		  confirmButtonColor: '#3085d6',
		  cancelButtonColor: '#d33',
		  confirmButtonText: 'Oui',
		  cancelButtonText: 'Non',
		  confirmButtonClass: 'btn btn-success',
		  cancelButtonClass: 'btn btn-danger',
		  buttonsStyling: true,
		  reverseButtons: false
		}).then((result) => {
		  if (result.value) {
			doRemoveEnt(selectedAgent);
		  } else {
			return false;
		  }
	})
}

function doRemoveEnt (id) {
	selectAgent(-1);
	removeCptContenantEntId(id);
	tEnt.splice(nEntById(id),1);
	updateAfterChangeEntites();
}

function ajouteEntite(ent) {
	if (ent.modePla=="manu") {
		ent.nbInd=-1;
		ent.tPla=[];
	}
	ent.id=trouveIdLibre();
	
	if (ent.nom=="") {
		ent.nom="Agent #"+ent.id;
	}
	
	tEnt.push(ent);
	updateAfterChangeEntites();
	selectAgent(ent.id);
	divListeEntites.scrollTop = divListeEntites.scrollHeight; // scroll tout en bas de la liste
}

function updateAfterChangeEntites () {
	refreshListeEnt();
	updateLegende();
	repeupleTout();
	initGraph();
	setTimeout(traceEntites,100);
}

function updateTableauxReacProd () {
	var s=byId("selectAgentEff");
	s.length=0;
	var option = document.createElement("option");
	option.text="(case vide)";
	option.value=0;
	s.add(option);
	for (let e of tEnt) {
		option = document.createElement("option");
		option.text=e.nom;
		option.value=e.id;
		s.add(option);
	}
		
		
	for (var n=1;n<6;n++) {
		var sr=byId("selectReac"+n);
		var sp=byId("selectProd"+n);
		var sps=byId("selectProdS"+n);
		sr.length=0;
		sp.length=0;
		sps.length=0;
		
		var option = document.createElement("option");
		option.text="-----";
		option.value=-1;
		sr.add(option);
		option = document.createElement("option");
		option.text="-----";
		option.value=-1;
		sp.add(option);
		option = document.createElement("option");
		option.text="-----";
		option.value=-1;
		sps.add(option);
		
		option = document.createElement("option");
		option.text="(case vide)";
		option.value=0;
		sr.add(option);

		
		for (let e of tEnt) {
			option = document.createElement("option");
			option.text=e.nom;
			option.value=e.id;
			sr.add(option);
			option = document.createElement("option");
			option.text=e.nom;
			option.value=e.id;
			sp.add(option);
			option = document.createElement("option");
			option.text=e.nom;
			option.value=e.id;
			sps.add(option);
		}
		sr.selectedIndex=0;
		sp.selectedIndex=0;
		sps.selectedIndex=0;
		
	}

}



function refreshListeEnt() {
	var d=byId("divListeEntites");
	var t="";
	for (let i=0;i<tEnt.length;i++) {
		let e=tEnt[i];
		t+="<div id=\"spanListeEnt"+e.id+"\" style=\"cursor:pointer;padding-left:0.2em;width:100%;\" ";
		t+="onclick=\"selectAgent("+e.id+")\" ";
		t+="ondblclick=\"dblClickEntite()\" "
		t+=">";
		t+=e.nom+"</div>";
	}
	d.innerHTML=t;
	selectAgent(selectedAgent);
}

function initRestrictionsDeplacements () {
	var n=selectedAgent;
	let dir="1111";
	if (n>0) {
		dir=entById(n).dir;
	}
	checkUp.checked=(dir[0]=="1");
	checkRight.checked=(dir[1]=="1");
	checkDown.checked=(dir[2]=="1");
	checkLeft.checked=(dir[3]=="1");
	
	
	hide (divSaisieEntite);
	affModale ("divRestreintDeplacements");
}

function butOKrestreindre() {
	affModale ("divSaisieEntite");
	hide (divRestreintDeplacements);
}

function initSaisieEntite() {
	selectAgent(-1);
	// toutes directions
	checkUp.checked=true;
	checkRight.checked=true;
	checkDown.checked=true;
	checkLeft.checked=true;
	// couleur aléatoire
	let h=Math.random()*255;
	let s=80;
	let v=80;
	let rgb=hsvToRgb(h, s, v);
	let coulAlea=fullColorHex(rgb[0],rgb[1],rgb[2]);
	byId("inputCoulEntite").jscolor.fromString(coulAlea);
	inputExpr.value="";
	// forme aléatoire
	let forme;
	let n=Math.floor(Math.random()*4);
	if (n==0) {forme="disque"}
	else if (n==1) {forme="cercle"}
	else if (n==2) {forme="carre"}
	else if (n==3) {forme="carrep"}
	hideId("divChoixCaractere");
	showId("divMobile");
	hideId("divChangeImage");
	byId("inputNomEntite").value="";
	byId("selectApparenceEntite").value=forme;
	byId("divTitreSaisieAgent").innerHTML="<b>Saisie d'un nouvel agent</b>";
	byId("butSaisieEntite").innerHTML="Ajouter cet agent";
	byId("butAnnulerEntite").innerHTML="Annuler";
	byId("checkEntDeplace").checked=true;
	
	byId("inputDemiVie").value=0;
	byId("inputNbEntites").value=10;
	byId("inputVitesseEnt").value=50;
	
	butFormule.style.outlineColor="rgba(0,0,0,0)";
	hideFieldsIfExpr();
	
	byId("selectModePlacement").value="auto";
	selectModePlacementChange();
	
	affModale('divSaisieEntite');
	if (tZon.length==0) {
		hideId("divZoneDepl");
		hideId("divZoneInit");
	} else {
		showId("divZoneDepl");
		showId("divZoneInit");
	}
	refreshListeZonesAut();
	byId("selectZoneAut").value=-1;
	byId("selectZoneInit").value=-1;
}


function repeupleTout () {
	iTemps=0;
	initListeImg();
	initDamier();
	initGraph();
	videInd();
	verifieDepasseLimitesEnv();
	peuplementAleatoire ();
	compteCasesVides ();
}

function videInd() {
	for (let ent of tEnt) {
		ent.tInd=[];
	}
}

function peuplementAleatoire () {
	// on commence par les manuels
	for (let ent of tEnt) {
		if (ent.modePla=="manu") {
			repeupleEntite(ent);
		} 
	}
	
	// ensuite seulement les automatiques, là où il reste de la place
	for (let ent of tEnt) {
		if (ent.modePla=="auto") {
			repeupleEntite(ent);
		} 
	}
}

function clickButIntroduitEntite() {
	if (selectedAgent<=0) {return false;}
	
	if (nbMaxInd>0) {
		if (nbTotalInd() >= nbMaxInd) {
			Swal.fire(
			  'Limite atteinte',
			  'Le nombre maximal d\'agents ('+nbMaxInd+') défini pour cet environnement a été atteint.',
			  'error'
			)
			return false;
		}
	}
	
	let ent=entById(selectedAgent);
	let cv=findCaseVideZone(ent.zoneInit);
	if (cv.x>=0) {
		x=cv.x;
		y=cv.y;
		rajouteEnt (ent.id,x,y);
	} else {
		Swal.fire(
			  'Plus de place',
			  'Il n\'y a aucune case de libre.',
			  'error'
		)
		return false;
	}
	traceEntites();
	updateEffectifLegende();
	selectAgent(selectedAgent);
}


function repeupleEntite(ent) {
	cons ("repeupleEntite "+ent.nom);
	var x,y;
	ent.tInd=[];
	
	if ((modePlaceEntites===true)&&(ent.modePla=="auto")) {return false;} // en mode placement, on ne met pas les automatiques qui sont vidées	
	
	var id=ent.id;
	
	if (ent.modePla=="auto") {
		let nbInd=ent.nbInd;
		for (let i=0;i<nbInd;i++) {
			let cv=findCaseVideZone(ent.zoneInit);
			if (cv.x>=0) {
				x=cv.x;
				y=cv.y;
				rajouteEnt (id,x,y);
			}
		}
	} else { // placement manuel
		var tPla=ent.tPla;
		for (let i=0;i<tPla.length;i+=2) {
			rajouteEnt (id,tPla[i],tPla[i+1]);
		}
		
	}
}

function supprimeTousIndiv() {
	for (let ent of tEnt) {
		ent.tInd=[];
	}
	initDamier();
}

function traceEntites() {
	var canv=byId("canvEnv");
	var ctx=canv.getContext('2d');
	if (iTemps<0) {return false}
	//ctx.fillStyle="white";
	//ctx.fillStyle="rgba(255,255,255,0.9)";
	ctx.clearRect(0,0,lCanv,hCanv);
	
	let r=lCanv/nbCol/2;
	let r2=r*0.95;
	for (let iEnt=0;iEnt<tEnt.length;iEnt++) {
		let ent=tEnt[iEnt];
		if (typeof(ent.expr)=="undefined") { // on ne trace pas les agents "formules"
			let forme=ent.forme;
			ctx.fillStyle=ent.coul;
			ctx.strokeStyle=ent.coul;
			
			for (let ind of ent.tInd) {
				let col=ind.x;
				let lig=ind.y;
				let x=col/nbCol*lCanv;
				let y=lig/nbLig*hCanv;
				
				ctx.drawImage(tImageEnt[iEnt],0,0,32,32,x+r-r2,y+r-r2,r2*2,r2*2);
			}
		}
	}
	
	if (zonesChanged) {
		traceZones();
	}
}


function bougeEntites() {
	for (let ent of tEnt) {
		bougeEnt(ent);
	}
}

function bougeIndividu (ind,direction,ent) {
	let x=ind.x;
	let y=ind.y;
	
	if (direction==0) {y--;} // 0 => haut
	else if (direction==1) {x++;}
	else if (direction==2) {y++;}
	else if (direction==3) {x--;}
	
	if (borderless===true) {
		if (x<0) {x=nbCol-1;}
		if (x>=nbCol) {x=0;}
		if (y<0) {y=nbLig-1;}
		if (y>=nbLig) {y=0;}
	} else {
		// l'environnement a des bords
		if (x<0) {x=0;}
		if (y<0) {y=0;}
		if (x>=(nbCol-1)) {x=nbCol-1;}
		if (y>=(nbLig-1)) {y=nbLig-1;}
	}
	
	let occup=damier[x][y];
	if (occup==0) {
		if ((ent.zoneDep==-1)||(ent.zoneDep==damierZ[x][y])) {
			damier[ind.x][ind.y]=0; // on vide l'ancienne position
			ind.x=x;
			ind.y=y;
			damier[x][y]=ent.id;
		}
	} 
}

function bougeEnt(ent) {
	if ((ent.dir=="0000")||(!ent.mobile)) {return false}
	let direction=0;
	if (ent.dir=="1111")  {
		// 4 directions autorisées
		for (let ind of ent.tInd) {
			if ((Math.random()*100)<ent.vitesse) {
				direction=Math.floor(Math.random()*4);
				bougeIndividu(ind,direction,ent);			
			}
		}
	} else {
		// seules certaines directions autorisées
		for (let ind of ent.tInd) {
			if ((Math.random()*100)<ent.vitesse) {
				let autor=false;
				while (!autor) {
					direction=Math.floor(Math.random()*4);
					autor=(ent.dir[direction]=="1");
				}
				bougeIndividu(ind,direction,ent);			
			}
		}	
	}
}

function indByXYandId (x,y,id) {
	var ent=entById(id);
	return ent.tInd.find(obj => {
	  return ((obj.x === x)&&(obj.y===y))
	})
}

function destroyEnt (x,y) {
	let id=damier[x][y];
	if (id==0) {return false;}
	let ent=entById(id);
	//console.log ("suppression de l'entité "+id+" présente en "+x,y);
	var i = ent.tInd.findIndex(obj => {
	  return ((obj.x === x)&&(obj.y===y))
	})
	var age=ent.tInd[i].age; 
	ent.tInd.splice(i,1);
	damier[x][y]=0;
	return age;
}

function rajouteEnt(id,x,y,age) {
	if (typeof age==="undefined") {age=0;}
	if ((modePlaceEntites==false)&&(nbMaxInd>0)) {
		if (nbTotalInd()>=nbMaxInd) {
			return false; // limite atteinte
		}
	}
	
	let ent=entById(id);
	ent.tInd.push({x:x,y:y,age:age});
	damier[x][y]=id;
}

function nbTotalInd () {
	var n=0;
	for (let e of tEnt) {
		n+=e.tInd.length;
	}
	return n;
}



function entById(id) {
	var ent = tEnt.find(obj => {
	  return obj.id === id
	})
	
	return ent;
}

function nEntById (id) {
	var nEnt = tEnt.findIndex(obj => {
	  return obj.id === id
	})
	
	return nEnt;
}

function getEntIndexById(id) {
	var ent = tEnt.findIndex(obj => {
	  return obj.id === id
	})
	
	return ent;
}

function afficheLegende (c) {
	if (c) {
		showId("panneauLegende");
	} else {
		hideId("panneauLegende");
	}
	redim();
}

function afficheLegendeEff (c) {
	afficheEff=c;
	updateLegende ();
}

function updateEffectifLegende() {
	if (!afficheEff) {return false;}
	for (let ent of tEnt) {
		let s=byId("spanLeg"+ent.id);
		s.innerHTML=getEffectif(ent);
	}
}


function getEffectif(ent) {
	// renvoie l'effectif d'une entité, qu'elle soit réelle ou formule
	if (typeof(ent.expr)=="undefined") {
		return ent.tInd.length;
	} else {
		let expr=ent.expr;
		let nbEnt=tEnt.length;
		for (let i=nbEnt;i>0;i--) {
			expr=expr.replaceAll("#"+i,"getEffectif(tEnt["+(i-1)+"])");
		}
		try {
			return (eval(expr));
		} catch (e) {
			let err=e.message;
			if (err.includes("stack size")) {
				swal("Erreur, il y a un autoréférencement (une formule qui fait appelle à elle même, directement ou indirectement).<br><br>"+err);
			} else {
				swal("Il y a une erreur dans la formule mathématique de l'effectif.<br><br>"+err);
			}
			stop();
			ent.expr="0//à corriger :  "+ent.expr
		}
	}
}


function updateLegende () {
	initListeImg();
	var d=byId("panneauLegende");
	var t="";
	for (let i=0;i<tEnt.length;i++) {
		let ent=tEnt[i];
		let c=ent.coul;
		let nom=ent.nom;
		if (afficheEff) {
			nom+="(<span id='spanLeg"+ent.id+"'>100</span>)";
		}
		let souligne="";
		let afficherMasquer="";
		if (ent.onGraph) {
			souligne="border-bottom: 0.2em solid "+c;
			afficherMasquer="ne plus";
		}
		t+="<div class='carreLegende' style='background:url("+tImageEnt[i].src+
		");background-size:contain;background-repeat:no-repeat;'></div><span title='Cliquer pour "+afficherMasquer+" afficher cette population sur le graphique' style='cursor:pointer;"+souligne+"' onclick='toggleOnGraph("+ent.id+")'>"+nom+"</span>";
	}
	d.innerHTML="<b>Légende : </b>"+t;
	updateEffectifLegende();
}

function getPfromD (d) {
	// calcule la probabilité de survie à chaque tour
	let d2=Math.log(0.5)/d;
	return Math.exp(d2);
}

function checkDemiVie () {
	for (e of tEnt) {
		let d=e.dvie;
		if (d>0) {
			let p=getPfromD(d);
			for (ind of e.tInd) {
				if (Math.random()>p) {
					destroyEnt (ind.x,ind.y);
					//console.log (e.nom," mort de vieillesse");
				}
			}
		}
	}
}

function vieillitEntites () {
	for (let e of tEnt) {
		for (let i of e.tInd) {
			i.age++;
		}
	}
}

function trouveIdLibre () {
	var id=0;
	var trouve=-1;
	do {
		id++;
		trouve=tEnt.findIndex(x => x.id === id);
	} while (trouve>=0) 
	return id;
}

