var graphiqueVisible=false;
var tGraph=[];
var echelleGraph=20;
const nbPts=1000;
var tMax,lGraph,hGraph,x0Graph,y0Graph,frameModulo,iDebut;
const nbMaxPtsGraph=20000;
var rangLisse=20;
var lissage=false;
var lastFin=0;

function changeVitesseGraph(v) {
	echelleGraph=Math.sqrt(v);
	traceGraph(true);
}

function traceGraph (force) {
	frameModulo=25-echelleGraph;
	updateEffectifLegende();
	if (graphiqueVisible==false) {return false}
	let iT=iTemps%nbMaxPtsGraph;
	var canv=byId("canvGraph");
	var ctx=canv.getContext('2d');
	var l=canv.width;
	var h=canv.height;
	var nbPtsAffiche=Math.round(nbPts*frameModulo);
	var lPoint=lGraph/nbPtsAffiche;

	iDebut=iTemps-nbPtsAffiche;
	
	if (iDebut<0) {iDebut=0;}
	
	var fin=iTemps*lPoint;
	if ((Math.abs(lastFin-fin)>=1)||force) {
		var h2=h*0.8;
		var y0=h-h*0.1;
		ctx.fillStyle="white";
		ctx.fillRect(0,0,l,h);
		
		var fs=Math.round(hEcran*0.015*100)/100;
		var tFl=fs/2;
		var tGr=Math.ceil(tFl/4);
		hGraph=h-margeY*2;
		lGraph=l-margeX*2;
		x0Graph=margeX;
		y0Graph=h-margeY;
		
		// axes
		ctx.strokeStyle="black";
		ctx.beginPath();
		ctx.moveTo(x0Graph,y0Graph);
		ctx.lineTo(x0Graph+lGraph,y0Graph);
		ctx.lineTo(x0Graph-tFl+lGraph,y0Graph-tFl);
		ctx.moveTo(x0Graph+lGraph,y0Graph);
		ctx.lineTo(x0Graph-tFl+lGraph,y0Graph+tFl);
		ctx.stroke();
		
		ctx.beginPath();
		ctx.moveTo(x0Graph,y0Graph);
		ctx.lineTo(x0Graph,y0Graph-hGraph);
		ctx.lineTo(x0Graph-tFl,y0Graph-hGraph+tFl);
		ctx.moveTo(x0Graph,y0Graph-hGraph);
		ctx.lineTo(x0Graph+tFl,y0Graph-hGraph+tFl);
		ctx.stroke();
		
		
		// titres axes
		ctx.fillStyle="black";
		ctx.textAlign="center";
		ctx.font=fs+"px Arial";
		ctx.fillText ("Effectif",margeX,margeY-fs*0.5);
		ctx.textAlign="left";
		ctx.fillText ("Temps",l-fs*3.5,y0Graph-fs*2);
		ctx.fillText ("(tours)",l-fs*3.5,y0Graph-fs*1);
		
		// on rétrécit la zone de traçage
		hGraph-=fs;
		lGraph-=fs;
		
		// recherche ordo maximale
		var ttMax=[];
		var ii=0;
		for (var i=0;i<tEnt.length;i++) {
			if (tEnt[i].onGraph) {
				ttMax[ii]=Math.max(...tGraph[i]);
				ii++;
			}
		}
		
		if (ii==0) { return false;} // pas de variable à grapher
		
		if (xGraphMouse>0) {
			let x = iDebut+ (xGraphMouse - x0Graph)*nbPtsAffiche/lGraph;
			let y = (y0Graph-yGraphMouse)/hGraph*tMax;
			byId("divCoords").innerHTML="t = "+Math.round(x)+"<br>eff = "+Math.round(y);
		} else {
			byId("divCoords").innerHTML="";
		}
		
		tMax=Math.max(...ttMax);
		
		// graduations ordonnées
		ctx.beginPath();
		var nbMaxOrd=Math.round((hGraph*0.7)/(fs*1.2));
		ctx.font=fs*0.8+"px Arial";
		var step=tMax/nbMaxOrd;
		step=arronditStep(step);
		ctx.textAlign="right";
		for (var i=step;i<=tMax;i+=step) {
			let y=y0Graph-hGraph*i/tMax;
			ctx.moveTo(x0Graph-tGr,y);
			ctx.lineTo(x0Graph+tGr,y);
			ctx.fillText(i,x0Graph-tGr,y+fs*0.3);
		}
		ctx.stroke();
		
		
		
		// graduations abscisses
		fs=fs*0.7;
		ctx.font=fs+"px Arial";
		ctx.beginPath();
		var nbMaxAbs=Math.round((lGraph*0.7)/(fs*1.8));
		var step=nbPtsAffiche/nbMaxAbs;
		step=arronditStep(step);
		ctx.textAlign="right";
		for (var i=Math.ceil(iDebut/step)*step;i<=iTemps;i+=step) {
			let x=(i-iDebut)*lPoint+x0Graph;
			ctx.moveTo(x,y0Graph-tGr);
			ctx.lineTo(x,y0Graph+tGr);
			ctx.save();
			ctx.translate(x,y0Graph);
			ctx.rotate(-Math.PI/2);
			ctx.fillText(i,-fs*0.4,fs*0.3);
			ctx.restore();
		}
		ctx.stroke();
		
		
		
		// courbe
		if (lissage) {
			for (var i=0;i<tEnt.length;i++) {
				if (tEnt[i].onGraph) {
					var clisse=lisse(tGraph[i],rangLisse);
					var lastx=-1;
					ctx.strokeStyle=tEnt[i].coul;
					ctx.beginPath();
					var firstDraw=true;
					for (let t=iDebut;t<iTemps;t++) {
						let x=(t-iDebut)*lPoint+x0Graph;
						if ((x-lastx)>=0.5) {
							let j=t%nbMaxPtsGraph-rangLisse;
							if ((j>=0)&&(j<clisse.length)) {
								let v=clisse[j];
								let y=y0Graph-hGraph*v/tMax;
								if (firstDraw) {ctx.moveTo(x,y);firstDraw=false;}
								else {ctx.lineTo(x,y);}
								lastx=x;
							}
						}
					}
					ctx.stroke();
				}
			}
		} else {
			for (var i=0;i<tEnt.length;i++) {
				if (tEnt[i].onGraph) {
					var lastx=-1;
					ctx.strokeStyle=tEnt[i].coul;
					ctx.beginPath();
					for (let t=iDebut;t<iTemps;t++) {
						let x=(t-iDebut)*lPoint+x0Graph;
						if ((x-lastx)>=0.5) {
							let j=t%nbMaxPtsGraph;
							let v=tGraph[i][j];
							let y=y0Graph-hGraph*v/tMax;
							if (x==0) {ctx.moveTo(x,y);}
							else {ctx.lineTo(x,y);}
							lastx=x;
						}
					}
				}
				ctx.stroke();
			}
		}
		traceTangente ();
		lastFin=fin;
	}
}

function resizeCanvGraph() {
	var d=byId ("divCanvGraph");
	var l=Math.ceil(d.getBoundingClientRect().width);
	var h=Math.ceil(d.getBoundingClientRect().height);
	var canv=byId("canvGraph");
	canv.width=l;
	canv.height=h;
	canv.style.width=l+"px";
	canv.style.height=h+"px";
	var canv=byId("canvTan");
	canv.width=l;
	canv.height=h;
	canv.style.width=l+"px";
	canv.style.height=h+"px";

	traceGraph(true);
}

function initGraph () {
	iTemps=0;
	tGraph=[];
	for (let i=0;i<tEnt.length;i++) {
		tGraph[i]=[];
	}
}

function addDataToGraph () {
	let iT=iTemps%nbMaxPtsGraph;
	for (let i=0;i<tEnt.length;i++) {
		tGraph[i][iT]=getEffectif(tEnt[i]);
	}
}

function afficheGraphique (c) {
	graphiqueVisible=c;
	if (c) {
		showId("divGraphique");
		traceGraph(true);
	} else {
		hideId("divGraphique");
	}
	checkGraphique.checked=c;
	resizeCanvGraph();	
}

function initResizeGraph () {
	byId("divGraphiquePoignee").addEventListener('mousedown', initialiseResize, false);
}


function initialiseResize(e) {
	window.addEventListener('mousemove', startResizing, false);
   	window.addEventListener('mouseup', stopResizing, false);
}

function startResizing(e) {
	let box=byId("divGraphique");
	let bCont=byId ("panneauCentre").getBoundingClientRect();
	box.style.width = (e.clientX - box.offsetLeft - bCont.x) + 'px';
	box.style.height = (e.clientY - box.offsetTop - bCont.y) + 'px';
	resizeCanvGraph();
}
function stopResizing(e) {
    window.removeEventListener('mousemove', startResizing, false);
    window.removeEventListener('mouseup', stopResizing, false);
}

function arronditStep(step) {
	var lo=Math.floor(Math.log10(step));
	var lo10=Math.pow(10,lo);
	var b=Math.floor(step/lo10);
	if (b==3) {b=5}
	if (b==4) {b=5}
	if (b==6) {b=10}
	if (b==7) {b=10}
	if (b==8) {b=10}
	if (b==9) {b=10}
	var c=b*lo10;
	return Math.ceil(c);
}

function toggleOnGraph (id) {
	entById(id).onGraph=!entById(id).onGraph;
	updateLegende();
	traceGraph(true);
}

function lisse (tab,range) {
	var l=tab.length;
	tab2=[];
	var moy;
	for (let i=0;i<(l-(range*2));i++) {
		moy=0;
		for (let j=-range;j<=range;j++) {
			moy+=tab[i+range+j];
		}
		tab2.push (moy/(2*range+1));
	}
	return tab2;
}

function checkLisseGraphique(c) {
	lissage=c;
	if (c) {
		byId("inputRangLisse").style.display="inline-block";
	} else {
		hideId("inputRangLisse");
	}
	traceGraph(true);
}

function changeRangLisse() {
	var v=byId("inputRangLisse").value*1;
	if (v<1) {v=1;}
	if (v>99) {v=99;}
	byId("inputRangLisse").value=v;
	rangLisse=v;
	traceGraph(true);
}