//gestion tangente
var tan={x0:0,y0:0,x1:0,y1:0,pente:""}
var graphDown=false;
var xGraphMouse,yGraphMouse;

function clearTangente () {
	var canv=byId("canvTan");
	var ctx=canv.getContext('2d');
	var l=canv.width;
	var h=canv.height;
	ctx.clearRect(0,0,l,h);
}

function traceTangente () {
	if (graphiqueVisible==false) {return false}
	if (iTemps==0) {return false}
	if (tan.pente=="") {return false}
	let iT=iTemps%nbMaxPtsGraph;

	var canv=byId("canvTan");
	var ctx=canv.getContext('2d');
	var l=canv.width;
	var h=canv.height;
	ctx.clearRect(0,0,l,h);
		
	var xx0,yy0,xx1,yy1;
	var fs=Math.round(hEcran*0.017*100)/100;
	
	xx0=x0Graph+(tan.x0-iDebut)/frameModulo*lGraph/nbPts;
	xx1=x0Graph+(tan.x1-iDebut)/frameModulo*lGraph/nbPts;
	yy0=y0Graph-hGraph*tan.y0/tMax;
	yy1=y0Graph-hGraph*tan.y1/tMax;
	
	//console.log (xx1,yy1);
	let d=(xx1-xx0)*(xx1-xx0)+(yy1-yy0)*(yy1-yy0);
	if (d>10) {
		ctx.beginPath();
		ctx.moveTo(xx0,yy0);
		ctx.lineTo(xx1,yy1);
		ctx.stroke();
		
		let xM=(xx0+xx1)/2;
		let yM=(yy0+yy1)/2;
		ctx.font=fs+"px Arial";
		if ( ((xx0<xx1)&&(yy1>yy0)) || ((xx0>xx1)&&(yy1<yy0)) ) {
			ctx.fillText("a = "+tan.pente,xM+fs,yM-fs);
		} else {
			ctx.fillText("a = "+tan.pente,xM+fs,yM+fs);
		}
		
	}
	
}

function graphMouseMove (e) {

	let rect = e.target.getBoundingClientRect();
	
	xGraphMouse=e.clientX - rect.left;
	yGraphMouse=e.clientY - rect.top;
	
	let x = iDebut+ (xGraphMouse - x0Graph)*frameModulo/lGraph*nbPts;;
	let y = (y0Graph-yGraphMouse)/hGraph*tMax;
	
	if (iTemps<=0) {
		byId("divCoords").innerHTML="";
	} else {
		byId("divCoords").innerHTML="t = "+Math.round(x)+"<br>eff = "+Math.round(y);
	}

	if (graphDown===false) {return false;}
	
	
	tan.x1=x;
	tan.y1=y;
	
	
	var pente=(tan.y1-tan.y0)/(tan.x1-tan.x0);
	var sPente;
	var aPente=Math.abs(pente);
	
	if (aPente==0) {
		sPente="0";
	} else if (aPente<0.001) {
		sPente=pente.toExponential(4);
	} else if (aPente>1000) {
		sPente=pente.toExponential(4);
	} else {
		sPente=pente.toPrecision(4);
	}
		
	sPente=sPente.replace(".",",");
	sPente=sPente.replace("e",".10^");
	sPente=sPente.replace("Infinity","∞");
	sPente=sPente.replace("-","− ");
		
	tan.pente=sPente;
	
	traceTangente();
}

function graphMouseDown (e) {
	graphDown=true;
	
	let rect = e.target.getBoundingClientRect();
	let x = iDebut+ (e.clientX - rect.left - x0Graph)*frameModulo/lGraph*nbPts;;
	let y = (y0Graph-(e.clientY - rect.top))/hGraph*tMax;
	
	tan.x0=x;
	tan.y0=y;
	
	graphMouseMove (e);
}

function graphMouseUp (e) {
	graphDown=false;
}

function graphMouseOut (e) {
	if (graphDown) {
		graphDown=false;
		tan.pente="";
		clearTangente();
	}
	byId("divCoords").innerHTML="";
	xGraphMouse=-1;
}