// traduction du fichier index.htm de Edumodeles Algo
let tTradHTML = [
"Edu'modèles - modélisation algorithmique","Edu'modèles - algorithmic modeling",
"Veuillez patienter ...","Please wait ...",
"Saisie des dimensions de l'environnement","Size of the environment",
"Nombre de colonnes (2-200) :","Number of columns (2-200):",
"Nombre de lignes (2-200) : ","Number of lines (2-200):",
"Nombre maximal d'agents à l'écran (0 = pas de limite) :","Maximum number of agents on screen (0 = no limit):",
"Pas de bords (lorsqu'un agent atteint un bord, il réapparaît de l'autre côté) :","No edges (when an agent reaches an edge, it reappears on the other side):",
"Opacité des zones (0-100) :","Zones' opacity (0-100):",
"Image de fond :","Background picture :",
"Supprimer l'image","Delete the image",
"Sélectionner le fichier image","Select image file",
"Choix d'une image pour illustrer un agent","Pick an image to illustrate an agent",
"Sélectionner le fichier image","Select image file",
"Aperçu :","Overview :",
"Restriction des déplacements d'un agent","Restrictions of an agent's movement",
"Cocher les directions autorisées","Check authorized movement",
"Saisie d'un nouvel agent","Selection of a new agent",
"Nom de l'agent :","Agent name:",
"Apparence :","Appearance:",
"Carré vide","Empty square",
"Carré plein","Full square",
"Caractère :","Symbol :",
"Changer l'image","Change the image",
"Couleur :","Color :",
"L'agent est mobile :","The agent is mobile:",
"Probabilité de déplacement par tour (en %) :","Probability of movement per turn (in %):",
"Déplacement autorisé vers :","Movement allowed to:",
"Demi-vie (en nombre de tours, 0 = infini) :" ,"Half-life (in number of turns, 0 = infinite):",
"Mode de placement :","Placement mode :",
"Automatique (aléatoire)","Automatic (random)",
"Nombre d'agents de ce type au démarrage :","Number of agents of this type at startup:",
"Zone de départ :","Starting zone:",
"Saisie d'une nouvelle zone","Creation of a new zone",
"Nom de la zone :","Zone name:",
"Couleur :","Color :",
"Nom de la règle :","Rule's name:",
"Saisie d'une nouvelle règle","Creation of a new rule",
"Réaction (rencontre entre plusieurs agents)","Reaction (interaction between several agents)",
"Génération spontanée d'agent(s)","Spontaneous generation of agent(s)",
"Age minimal des réactifs (en nombre de tours) :","Minimum age of reagents (in number of turns):",
"Probabilité de réaction à chaque tour (en %) :","Probability of reaction at each turn (in %):",
"Conditionner cette règle à l'effectif d'un agent :","This rule depends on the number of agents:",
"Active si l'effectif de","Active if the workforce of",
"inférieur à","lesser than",
"égal à","equal to",
"supérieur à","greater than",
"différent de","different from",
"Probabilité de génération spontanée à chaque tour (en %) :","Probability of spontaneous generation at each turn (in %):",
"Nombre de générations spontanées par tour :","Number of spontaneous generations per turn:",
"Produits créés spontanément","Products created spontaneously",
"Zone où la règle est active :","Zone where the rule is active:",
"En cas de réaction la zone devient :","In case of reaction, the zone becomes:",
"Le premier réactif doit forcément être au centre de la réaction :","The first reagent must necessarily be at the center of the reaction:",
"Placement manuel<br>des agents de type","Manual placement<br>of the following agent's type",
"Utiliser le crayon pour placer des agents sur l'environnement en cliquant sur le quadrillage.","Use the pencil to place the agents in the environment by clicking on the grid.",
"Utiliser la gomme pour retirer des agents un par un en cliquant sur le quadrillage.","Use the eraser to remove the agents one by one by clicking on the grid.",
"Utiliser la corbeille pour retirer tous les agents de ce type.","Use the trash bin to remove all agents of this type.",
"Nombre d'agents de ce type à l'écran :","Number of agents of this type on screen:",
"Placement terminé","Placement completed",
"Zones définies :","Defined zones:",
"Ajouter une zone","Add a zone",
"Modifier cette zone","Edit this zone",
"Supprimer cette zone","Delete this area",
"Délimitation de la zone sélectionnée :","Delimitation of the selected area:",
"Pot de peinture","Paint bucket",
"Interface niveau expert :","Expert level interface:",
"Environnement :","Environment:",
"Zones","Zones",
"Grille visible : ","Visible grid:",
"Agents (entités) :","Agents (entities):",
"Ajouter un agent","Add an agent",
"Supprimer cet agent","Delete this agent",
"Modifier cet agent","Edit this agent",
"Placer cet agent","Place this agent",
"Introduire cet agent","Introduce this agent",
"Dépeupler cet agent","Depopulate this agent",
"Légende :","Legend:",
"Effectif :","Numbers :",
"Règles (comportements) :","Rules (behaviors):",
"Ajouter une règle","Add a rule",
"Supprimer cette règle","Delete this rule",
"Modifier cette règle","Edit this rule",
"Suspendre cette règle","Suspend this rule",
"module algorithmique (multi-agents)","algorithmic module (multi-agents)",
"Ecran d'accueil","Homepage",
"Modèle :","Model :",
"Nouveau modèle","New model",
"Charger un modèle","Load a model",
"Enregistrer ce modèle","Save this model",
"Exporter un résumé","Export a summary",
"Graphique :","Graph :",
"Afficher :","Display :",
"Lisser :","Smooth :",
"Echelle horizontale :","Horizontal scale:",
"Animation :","Animation :",
"Tours de chauffe : ","Heating turns:",
"Durée (0 = infini) :","Duration (0 = infinite):",
"Vitesse de l'animation :","Animation speed:",
"Nombre de<br>tours écoulés :","Number of <br> laps completed:",
"Auteur : P.COSENTINO","Author : P.COSENTINO",
"D'après ","From ",
"Légende :","Legend :",
"Environnement","Environment",
"Exporter","Export",
"Paramètres","Settings",
"Terminé","Completed",
"Crayon","Pencil",
"Gomme","Rubber",
"Corbeille","trash bin",
"Réactifs","Reagents",
"Produits","Products",
"Manuel","Manual",
"Croix","Cross",
"Caractère","Symbol",
"Image","Image",
"Point","Point",
"Disque","Disk",
"Cercle","Circle",
"Annuler","Cancel",
"Restreindre","Restrict",
"Plus cette probabilité est élevée, plus l'agent se déplacera rapidement.&#013;Une probabilité de 100 signifie que l'agent se déplace à chaque tour.",,
"Restreindre le déplacement à certaines directions","Restrict movement to specific directions",
"La demi-vie correspond au nombre de tours au bout duquel la moitié des agents auront disparu.","The half-life corresponds to the number of turns at the end of which half of the agents will have disappeared.",
"Le produit se formera sur la même case que le réactif correspondant.","The product will form on the same square as the corresponding reagent.",
"Le produit hérite de l'âge du réactif correspondant.","The product inherits the age of the corresponding reagent.",
"Active ou désactive le mode expert où davantage de fonctionnalités sont disponibles","Activate or deactivate expert mode where more functionality are available",
"Paramétrer l'environnement","Configure the environment",
"Définir/modifier des zones","Define / modify zones",
"Cache ou affiche la grille par dessus l'environnement","Hide or show the grid over the environment",
"Retourne à l'écran qui vous permet de choisir le type de modélisation souhaitée","Go back to the homescreen to choose the type of desired model",
"Masquer ou afficher le graphique","Hide or show graph",
"Lisse le graphique (moyenne mobile)","Smooth the graph (moving average)",
"Exporter le graphique au format CSV pour l'ouvrir dans un tableur","Export the graph in CSV format to open it in a spreadsheet",
"Le modèle tournera durant un certain nombre de tours avant le temps t=0","The model will run for a certain number of turns before time t = 0",
"Nombre de tours durant lequel le modèle tournera","Number of turns during which the model will run",
"Réinitialiser (redémarrer) le modèle","Reset (restart) the model",
"Démarrer/reprendre l'animation","Start / resume animation",
"Avancer d'un tour","Go forward one turn",
"Mettre en pause le modèle","Pause the model",
"Une application basée sur NetBioDyn pour créer des modèles algorithmiques simplifiés en SVT.","An application based on NetBioDyn, to create simplified algorithmic models for science classes."
]