function centreCtr (id) {
	var nId=id*1;
	id=to2digits(nId);
	var lien=tLien[nId];

	var courbe=byId("path"+id);
	var var1=byId("var"+lien.idV1);
	var var2=byId("var"+lien.idV2);

	var ctrc=byId("ctr"+id);
	
	var es_out=var1.getElementsByClassName("es_droit")[0];
	var es_in=var2.getElementsByClassName("es_gauche")[0];

	var rect_out=es_out.getBoundingClientRect();
	var rect_in=es_in.getBoundingClientRect();
	var rect_ctrc=ctrc.getBoundingClientRect();
	
	var x1=Math.round(rect_out.left+rect_out.right)/2;
	var x2=Math.round(rect_in.left+rect_in.right)/2;
	var y1=Math.round(rect_out.top+rect_out.bottom)/2;
	var y2=Math.round(rect_in.top+rect_in.bottom)/2;
	var l=Math.round(-rect_ctrc.left+rect_ctrc.right);
	var h=Math.round(-rect_ctrc.top+rect_ctrc.bottom);
	
	
	var x=(x1+x2)/2-l/2;
	var y=(y1+y2)/2-h/2;
	
	
	ctrc.style.left=x+"px";
	ctrc.style.top=y+"px";
}

function deplacePoignee (id,x,y) {
	var nId=id*1;
	id=to2digits(nId);
	var ctrc=byId("ctr"+id);
	ctrc.style.left=x;
	ctrc.style.top=y;
	updateSVG(id);
}

function updateAllSVG () {
	for (var i=1;i<tLien.length;i++) {
		updateSVG(to2digits(i));
	}
}

function updateSVG (id) {
	var nId=id*1;
	id=to2digits(nId);
	var lien=tLien[nId];
	//console.log ("update de "+id);
	var courbe=byId("path"+id);
	var var1=byId("var"+lien.idV1);
	var var2=byId("var"+lien.idV2);
	//console.log ("var #1 : "+lien.idV1+" var #2 : "+lien.idV2);

	var ctrc=byId("ctr"+id);
	
	var es_out=var1.getElementsByClassName("es_droit")[0];
	var es_in=var2.getElementsByClassName("es_gauche")[0];

	var rect_out=es_out.getBoundingClientRect();
	var rect_in=es_in.getBoundingClientRect();
	var rect_ctrc=ctrc.getBoundingClientRect();
		
	var x1=Math.round(rect_out.left+rect_out.right)/2;
	var x2=Math.round(rect_in.left+rect_in.right)/2;
	var y1=Math.round(rect_out.top+rect_out.bottom)/2;
	var y2=Math.round(rect_in.top+rect_in.bottom)/2;
	var xc=Math.round(rect_ctrc.left+rect_ctrc.right)/2;
	var yc=Math.round(rect_ctrc.top+rect_ctrc.bottom)/2;
		
	var xA=x1;
	var yA=y1;
	var xB=x2;
	var yB=y2;
	
	var xq=2*xc-0.5*xA - 0.5*xB;
	var yq=2*yc-0.5*yA - 0.5*yB;
	
	var d="M "+x1+","+y1+
	" Q "+xq+","+yq+
	" "+x2+","+y2;
	//console.log (d);
	
	courbe.setAttribute('d',d);
		
	if (id!="00") {
		var coul=lien.coul;
		var v2=tVar[lien.idV2*1];
		if (lien.autoCoul) {
			if (lien.typeRel=="val") {
				coul="FF00FF";
			} else {
				if (lien.selType=="aug") {coul="FF0000";} 
				if (lien.selType=="dim") {coul="0000FF";}
			}
		}
		if (v2.typeVar=="p") {
			coul="FF7700";
		}
		courbe.setAttribute('stroke',"#"+coul);
		updateAnglePath (id);
	}
}

function updatePathMobile () {
	var courbe=byId("path00");
	var var1=byId("var"+idMobile);
	var noeudMobile=byId("noeud_mobile");
	show(courbe);
	
	var es_out=var1.getElementsByClassName("es_droit")[0];
	var es_in=noeudMobile;

	var rect_out=es_out.getBoundingClientRect();
	var rect_in=es_in.getBoundingClientRect();
		
	var x1=Math.round(rect_out.left+rect_out.right)/2;
	var x2=Math.round(rect_in.left+rect_in.right)/2;
	var y1=Math.round(rect_out.top+rect_out.bottom)/2;
	var y2=Math.round(rect_in.top+rect_in.bottom)/2;
	
	var d="M "+x1+","+y1+
	" L "+x2+","+y2;
			
	courbe.setAttribute('d',d);
}

function updateSVGenLienAvec (id) {
	for (var i=1;i<tLien.length;i++) {
		var lien=tLien[i];
		if ((lien.idV1==id)||(lien.idV2==id)) {updateSVG(i);} 
	}
}

function creeCourbe (nId) {
	var id=to2digits(nId);
	var original = byId('path');
	var clone = original.cloneNode(true); 
	clone.id = "path" + id; 
	if (nId>0) {show(clone);}
	original.parentNode.appendChild(clone);	
	svgBringToFront (byId("svgPath"));
}

function updateLien (id) {
	var nId=id*1;
	var courbe=byId("path"+id);
	var ctrc=byId("ctr"+id);
	if (tLien[nId].suppr===true) {
		hide(courbe);	
		hide(ctrc);
		return false;
	} else {
		show(courbe);
		show(ctrc);
	}
	
	
	var act=tLien[nId].actif;
	if (act) {
		ctrc.style.backgroundImage = "url('images/triangleCercle.png')";
		courbe.setAttribute("stroke-opacity",0.9);
	} else {
		ctrc.style.backgroundImage = "url('images/circleX.png')";
		courbe.setAttribute("stroke-opacity",0.1);
	}
}


function creePath (id,coul,nouvDiv) {
	var nId=id*1;
	var id=to2digits(nId);
	if (nouvDiv) {
		creeCourbe (nId)
		creeCtr (nId);
	}
	
	
	if (nId!="00") {
	
		updateLien (id);
		centreCtr (nId);
		updateSVG (nId);
	}
}

function creeCtr (nId) {
	var id=to2digits(nId);
	var original = byId('ctr00');
    var clone = original.cloneNode(true); 
	clone.id = "ctr" + id; 
	if (nId>0) {show(clone);}
	dragElement(clone);	
	original.parentNode.appendChild(clone);
}

svgBringToFront = function (domElement) {
  var parent = domElement.parentElement;
  parent.removeChild(domElement);
  parent.appendChild(domElement);
}

function updateAnglePath(id) {
	var nId=id*1;
	var lien=tLien[nId];
	var courbe=byId("path"+id);
	var var1=byId("var"+lien.idV1);
	var var2=byId("var"+lien.idV2);
	//console.log ("var #1 : "+lien.idV1+" var #2 : "+lien.idV2);

	var ctrc=byId("ctr"+id);
	
	var es_out=var1.getElementsByClassName("es_droit")[0];
	var es_in=var2.getElementsByClassName("es_gauche")[0];

	var rect_out=es_out.getBoundingClientRect();
	var rect_in=es_in.getBoundingClientRect();
	var rect_ctrc=ctrc.getBoundingClientRect();
	
	var x1=Math.round(rect_out.left+rect_out.right)/2;
	var x2=Math.round(rect_in.left+rect_in.right)/2;
	var y1=Math.round(rect_out.top+rect_out.bottom)/2;
	var y2=Math.round(rect_in.top+rect_in.bottom)/2;
	var xc=Math.round(rect_ctrc.left+rect_ctrc.right)/2;
	var yc=Math.round(rect_ctrc.top+rect_ctrc.bottom)/2;
	
	var xA=x1;
	var yA=y1;
	var xB=x2;
	var yB=y2;
	
	var xq=2*xc-0.5*xA - 0.5*xB;
	var yq=2*yc-0.5*yA - 0.5*yB;
		
	var anchor1={x:x1,y:y1};
	var anchor2={x:x2,y:y2};
	var control={x:xq,y:yq};
	var t=0.5;
  let u = (1 - t);
  let dx = (u * control.x + t * anchor2.x) - (u * anchor1.x + t * control.x);
  let dy = (u * control.y + t * anchor2.y) - (u * anchor1.y + t * control.y);
  
  var angle=Math.atan2(dy, dx);
  var deg=angle*180/Math.PI+90;

  
   ctrc.style.webkitTransform = 'rotate('+deg+'deg)'; 
    ctrc.style.mozTransform    = 'rotate('+deg+'deg)'; 
    ctrc.style.msTransform     = 'rotate('+deg+'deg)'; 
    ctrc.style.oTransform      = 'rotate('+deg+'deg)'; 
    ctrc.style.transform       = 'rotate('+deg+'deg)'; 

  
  
  
  return angle;
}